/* $Header:   F:/source/cwright/cwstart/asm.c_v   1.30   26 Jul 1993 10:16:42   ericj  $ */
/*
 *
 *                Copyright 1991,1992,1993 Starbase Corp.
 *                        All rights reserved
 *
 *    This source code is provided to the purchaser of the product
 *    for the purpose of allowing the purchaser to customize and/or
 *    extend the functionality of the product.  The source code   
 *    remains the property of Starbase Corp. with all rights reserved.
 *    Any modifications to the source code are considered derivative
 *    works and all rights thereto are reserved to Starbase Corp. except
 *    that the purchaser may use the modified product in the same
 *    permitted manner as the unmodified product.  It is expressly
 *    prohibited to distribute in any manner any part of the original
 *    source code, whether in source or object form, without the
 *    express written permission from Starbase Corp.
 *
 *    Owner:
 *        Starbase Corporation
 *        1075 NW Murray Blvd., Suite 268
 *        Portland OR 97229
 *
 */

/* #include "win_filt.h"	*/
#include <windows.h>
#include <string.h>
#include <ctype.h>
#include "exports.h"
#include "cwstart.h"

LIBMAIN    /* defines the LibMain() */


#define MAX_BUF_LEN    100

static LPVOID _pl1_hash_names        = NIL;    /* pointer to the hash table containing */
                                               /* all 'XXX' keyword names. */

static LPVOID _pl1_hash_names_1      = NIL;    /* pointer to optional hash table containing */
static int    _pl1_hash_size_1       = 47;     /* user defined keyword names and size of
                                               /* table. When created these key
                                               /* are set to Color Alternate5 */           
                        

static LPVOID _pl1_hash_names_2      = NIL;    /* pointer to optional hash table containing */
static int    _pl1_hash_size_2       = 47;     /* user defined keyword names and size of
                                               /* table. When created these key
                                               /* are set to Color Alternate6 */              

static LPVOID _pl1_hash_templates    = NIL;    /* pointer to the hash table containing */
                                               /* an abbreviated name and its template */

/* Define a structure to hold an abbreviation and the template to be
 * expanded when the abbreviation is entered into the buffer.
 * This structure will be the element in the hash table _pl1_hash_templates.
 */
typedef struct _LanguageTemplate {         
    LPSTR abbrev;
    LPSTR template;
} LanguageTemplate;


/* This string contains all keyword names which will be indented an extra level.
 */
LPSTR PL1_INDENT_STR = "BEGIN\377BLK\377DEL\377SEL\377SELECT\377";

/*
 * _pl1_templates[] contains the keyword abbreviation and the template for the
 * abbreviation.  To add a new name, insert it before the NIL entry or
 * call _pl1_assign_template().
 *
 * The special characters within the template are:
 *
 *     \n - new line
 *     &  - cursor position after template insertion
 *     @  - backspace
 *     \c - insert 'c' literally
 */
LanguageTemplate _pl1_templates[] = {
//		Abbreviation 	Template
    	{ "BEGIN",  	"BEGIN\n\tEND"},
        { "BLK",    	"BLKSIZE("},    
        { "DEL",    	"DELETE FILE"},           
        
        { "SEL",    	"SELECT\n\tWHEN  &\nOTHERWISE:\n@;" },
        { "SELECT", 	"SELECT\n\tWHEN  &\nOTHERWISE:\n@;" },
        
    	{ NIL,      NIL              },                
};

 
 /* Define the list of 'PL1' keyword names to appear in
 * the keyword color if language coloring is enabled.
 */
LPSTR _pl1_names[] = {
    "ALLOC",           "ALLOCN",             "ASM",
	"ATTN",            "AUTO",               "BIN",              "BUF",
	"CHAR",            "CHARG",              "COL",              "CPLN",
	"CPLX",            "COND",               "CONN",             "CTL",
	"CONV",            "CSTG",               "DEC",
	"DCL",             "DFT",                "DEF",
	"ENV",             "EXCL",               "EXT",              "FOFL",
	"INIT",            "INT",                "IRRED",            "NOCHARG",
	"NOCONV",          "NOFOFL",             "NOOFL",            "NOSTRG",
	"NOSTRZ",          "NOSUBRG",            "NOUFL",            "NOZDIV",
	"OTHER",           "OFL",                "PIC",              "PTR",
	"POS",             "PREC",               "PROC",             
	"RED",             "SEQL",               "STMT",             "STG",
	"STRG",            "STRZ",               "SUBRG",            "UNAL",
	"UNBUF",           "UNDF",               "UFL",              "VAR",
	"ZDIV",
	"ABS",             "ACOS",               "ADD",
	"ADDBUF",          "ADDR",               "ALIGNED",          "ALL",
	"ALLOCATE",        "ALLOCATION",         "ANY",              "AREA",
	"ARG",             "AREAS",              "ASCII",            "ASIN",
	"ASSEMBLER",       "ASMTDLI",            "ATAN",             "ATAND",
	"ATANH",           "ATTENTION",          "AUTOMATIC",        "CALL",
	"BACKWARDS",       "BASED",              "BEGIN",
	"BINARY",          "BINARYVALUE",        "BIT",              "BKWD",
	"BLKSIZE",         "BOOL",               "BUFFERED",         "BUFFERS",
	"BUFFOFF",         "BUFND",              "BUFNI",            "BUFSP",
	"BUILTIN",         "BX",                 "BY",               "B4",
	"CALL",            "CEIL",               "CHAR",             "CHARACTER",
	"CHARGRAPHIC",     "CHECK",              "CLOSE",            "COBOL",
	"COLOUMN",         "COMPILETIME",        "COMPLETION",       "COMPLEX",
	"CONDITION",       "CONJG",              "CONNECTED",        "CONSECUTIVE",
	"CONTROLLED",      "CONVERSION",         "COPY",             "COS",
	"COSD",            "COSH",               "COUNT",            "COUNTER",
	"CTLASA",          "CTL360",             "CURRENTSTORAGE",   
	"DATAFIELD",       "DATE",               "DATETIME",         "DB",
	"DBCS",            "DECIMAL",            "DECLARE",
	"DEFAULT",         "DEFINED",            "DELAY",
	"DELETE",          "DESCRIPTORS",        "DIM",              "DIRECT",
	"DISPLAY",         "DIVIDE",             "DO",               
    "EBCDIC",          "EDIT",               "ELSE",
	"EMPTY",           "END",            
	"ENDFILE",         "ENDPAGE",            "ENTRY",            "ENTRYADDR",
	"ENVIRONMENT",     "ERF",                "ERFC",             "ERROR",
	"EVENT",           "EXCLUSIVE",          "EXIT",             "EXP",
	"EXTERNAL",        "FB",                 "FBS",
	"FETCH",           "FILE",               "FINISH",           "FIXED",
	"FIXEDOVERFLOW",   "FLOAT",              "FLOOR",            "FORMAT",
	"FORTRAN",         "FREE",               "FROM",             "FS",
	"GENERIC",         "GENKEY",             "GET",              "GRAPHIC",
	"GX",              "HBOUND",             "HIGH",             
	"IF",              "IGNORE",             "IMAG",
	"IN",              "INDEX",              "INDEXAREA",
	"INDEXED",         "INITIAL"             "INPUT",            "INTER",
	"INTERNAL",        "INTO",               "IRREDUCIBLE",      
	"KEY",             "KEYED",              "KEYFROM",          "KEYLENGTH",
	"KEYTO",           "LABEL",              "LANGLVL",          "LBOUND",
	"LEAVE",           "LENGTH",             "LEYLOC",           "LIKE",
	"LINE",            "LINENO",             "LINESIZE",         "LOCATE",
	"LOG",             "LOG10",              "LOG2",             "LOW",
	"MAIN",            "MAX",                "MIN",
	"MOD",             "MPSTR",              "MULTIPLY",         "NAME",
	"NCP",             "NOCHARGRAPHIC",      "NOCHECK",          "NOCONVERSION",
	"NOEXECOPS",       "NOFIXEDOVERFLOW",    "NOLOCK",           "NOMAP",
	"NOMAPIN",         "NOMAPOUT",           "NOOVERFLOW",       
	"NORESCAN",        "NOSIZE",             "NOSTRINGRANGE",    "NOSTRINGSIZE",
	"NOSUBSCRIPTRANGE","NOUNDERFLOW",        "NOWRITE",
	"NOZERODIVIDE",    "NULL",               "OFFSET",
	"ON",              "ONCHAR"              "ONCODE",           "ONCOUNT",
	"ONFILE",          "ONKEY",              "ONLOC",            "ONSOURCE",
	"OPEN",            "OPTIONS",            "ORDER",            "OTHERWISE",
	"OUTPUT",          "OVERFLOW",           "PAGE",             
	"PAGESIZE",        "PARMSET",            "PASSWORD"          "PENDING",
	"PIC",             "PICTURE",            "PLICANC",          "PLICKPT",
	"PLIDUMP",         "PLIREST",            "PLIRETC",          "PLIRETV",
	"PLISRTA",         "PLISRTB",            "PLISRTC",          "PLISRTD",
	"PLITDLI",         "PLITEST",            "PLIXHD",           "PLIXOPT",
	"POINTER",         "POINTERADD",         "POINTERVALUE",     "POLY",
	"POSITION",        "PRECISION",          "PRINT",            
	"PRIORITY",        "PROCEDURE",          
	"PROD",            "PUT",                "RANGE",
	"READ",            "REAL",               "RECORD",           "RECSIZE",
	"RECURSIVE",       "REDUCIBLE",          "REENTRANT",        "REFER",
	"REGIONAL",        "RELEASE",            "REORDER",          "REPEAT",
	"REPLY",           "REPORT",             "REREAD",           "RESCAN",
	"RETCODE",         "RETURN",             "RETURNS",          "REUSE",
	"REVERT",          "REWRITE",            "ROUND",           
	"SAMEKEY",         "SBCS",               "SCALARVARYING",    "SELECT",
	"SEQUENTIAL",      "SET",                "SIGN",             "SIGNAL",
	"SIN",             "SIND",               "SINH",             "SIS",
	"SIZE",            "SKIP",               "SNAP",
	"SPROG",           "SQRT",               "STATEMENT",        "STATIC",
	"STATUS",          "STOP",               "STORAGE",          "STREAM",
	"STRING",          "STRINGRANGE",        "STRINGSIZE",       "SUBSCRIPTRANGE",
	"SUBSTR",          "SUM",                "SYSIN",            "SYSNULL",
	"SYSPRINT",        "SYSTEM",             "TAN",
	"TAND",            "TANH",               "TASK",             "THEN",
	"TIME",            "TITLE",              "TO",
	"TOTAL",           "TP",                 "TRANSIENT",        "TRANSLATE",
	"TRANSMIT",        "TRKOFL",             "TRUNC",            "TSTAMP",
	"UNALIGNED",       "UNBUFFERED",         "UNDEFINEDFILE",
	"UNDERFLOW",       "UNLOCK",             "UNSPEC",           "UNTIL",
	"UPDATE",          "VALUE",              "VARIABLE",
	"VARYING",         "VB",                 "VBS",              "VERIFY",
	"VS",              "VSAM",               "WAIT",             "WHEN",
	"WHILE",           "WRITE",              "ZERODIVIDE",         
	NIL
};

static long _pl1_in_comment( long offset );
static long _pl1_find_comment_start( void );
static long _pl1_find_comment_end( UINT style );
static BOOL _pl1_in_string( long offset );

void DLL _pl1_init( void );
BOOL DLL _pl1_expand( void );
void DLL _pl1_language_colors_update( long firstline, long lastline );
void DLL _pl1_language_colors( long numlines );
void DLL _pl1_assign_template( LPSTR abbrev, LPSTR template );
void DLL _pl1_add_keyword( LPSTR keyword, int table );
BOOL DLL _pl1_indent( void );
void DLL _pl1_hash_size( int ht, int size );
void DLL _pl1_routines( void);


void DLL 
_init()
{
    _pl1_init();
}   

/*
 ** _pl1_init()
 *
 *  Initialize this module by exported any required functions and
 *  the hash tables needed to support indenting, template expandion
 *  and keyword coloring.
 */
void DLL
_pl1_init( void )
{
    static BOOL firstTime = TRUE;
    int    i;

    if (firstTime)
    {
        /* _xxx language handling functions get called via LibFunctionExec,
         * so they must be exported.
         */
        LibExport( "BOOL _pl1_expand");
        LibExport( "_pl1_assign_template LPSTR LPSTR");
        LibExport( "BOOL _pl1_indent");
        LibExport( "_pl1_language_colors_update long long");
        LibExport( "_pl1_language_colors long");
        LibExport( "_pl1_add_keyword LPSTR int");
        LibExport( "_pl1_hash_size int int");
		LibExport( "_pl1_routines" );

        firstTime = FALSE;

        /* Create a hash table to hold all of the 'XXX' keyword names.
         */
        _pl1_hash_names = HashCreateTable( 539 /* a prime # */, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _pl1_names[ i ] != NIL )
        {
            LPSTR XFAR *lpf = (LPSTR XFAR *)HashGetEntry( _pl1_hash_names, 
                    _pl1_names[i], strlen( _pl1_names[i] ) );
            if (lpf)
            {
                *lpf = StrNew( _pl1_names[i] );
                i++;
            }
        }

        /* Create a hash table to hold all of the 'XXX' template names.
         */
        _pl1_hash_templates = HashCreateTable( 17 /* a prime # */, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _pl1_templates[ i ].abbrev != NIL )
        {
            _pl1_assign_template( _pl1_templates[i].abbrev, _pl1_templates[i].template );
            i++;
        }
    }
	CompilerNewExt( ".pl1" );
}


void DLL
_pl1_hash_size( int ht, int size )
{
	if (size > 0)
	{
		if (ht == 1)
			_pl1_hash_size_1 = size;
		else if (ht == 2)
			_pl1_hash_size_2 = size;
	}
}


/*
 ** _pl1_expand()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'XXX' language template expansion.  This function
 *    is normally bound to the <SPACE> key.  When invoked, it reads the 
 *    previous word.  If the word is in the list of defined templates,
 *    the template is extracted and inserted.  Some characters in the 
 *    templates have special meanings. They are:
 *
 *       \n - new line
 *       &  - cursor position after template insertion
 *       @  - backspace
 *       \  - take next character literally
 */
BOOL DLL
_pl1_expand( void )
{
    LPVOID htEntry;
    LPSTR  _pl1_string = NULL;
    LPSTR  str;
    int    i = 0;

    MarkSavePos();

    /* Check to see if we are currently positioned inside a 'XXX' comment
     */
    if (_pl1_in_comment( -1L ) != -1)
        goto _pl1_expand_incomplete;

    str = BufReadStr( 65535 );
    while (str[i] && !isspace(str[i]))
        i++;
    str[i] = '\0';

    _pl1_string = StrTrim( str, " \t" );
    StrFree( str );

    if (!_pl1_string)
        goto _pl1_expand_incomplete;

    /* Search for a keyword match in the hash table.
     */
    htEntry = HashFindEntry( _pl1_hash_templates, _pl1_string, strlen( _pl1_string ) );
    StrFree( _pl1_string );

    if (htEntry)
    {
        /* A template exists for the current keyword, delete the keyword
         * and insert the template.
         */
        MarkDropPos( 1 );
        str = *(LPSTR*)htEntry;
        BufDelToEOL();

        _ext_expand_template( str );

    } 
    else
        goto _pl1_expand_incomplete;
    return TRUE;

_pl1_expand_incomplete:
    MarkRestorePos();

    return FALSE;
}

/*
 ** _pl1_language_colors_update()
 *
 *  This function does an intermediate update of the colors within
 *  a range of line numbers (firstline and lastline).  It must also
 *  determine if the first and last line specified are within a
 *  comment and act appropriately.
 */
void DLL
_pl1_language_colors_update( long firstline, long lastline )
{
	long startoff;
	long ec_line  = 0; /* end comment line */
	UINT style    = 0;
	int  color;

	if (firstline && lastline)
	{
		/* Begin coloring at the previous comment if
		 * currently located in the middle of one.
		 */
		_PosInit( 0 );
		if (firstline == 1)
			_PosPrevLine( 0L );
		else
			_PosNextLine( firstline - 1);

		startoff = _PosQOffset();
		if ( _pl1_find_comment_start() == 1)
		{
			startoff  = _PosQOffset();

			_PosNextChar();   /* move off of the comment */
			_PosNextChar();

			style = 1;

			if (_pl1_find_comment_end( style ))
				ec_line = _PosQLine();
		}

		_PosInit( startoff );
		_PosCurrentCharNL();
		while (_PosPrevCharNL() && (_PosPrevCharNL() == '\\'))
		{
			_PosPrevLine( 0L );
			_PosCurrentCharNL();
			startoff  = _PosQOffset();
		}

		_PosInit( startoff );
		firstline = _PosQLine();

		/* End coloring at the next comment if
		 * currently located in the middle of one.
		 */
		_PosInit( 0 );
		color = _PosQColor();
		_PosNextLine( lastline - 1 );
		_PosNextLine( 0 );

		if (color || _PosQColor())
		{
			_pl1_find_comment_end( style );
			lastline = _PosQLine();
		}
		else if (_pl1_find_comment_end( style ) == 2)
			lastline = _PosQLine();


		SysSetSystemFlags( SYSTEM_DELAY_ATTR_CHANGES );

		if (!ec_line)
			AttrSetColor( firstline, lastline, 1L, 0x7FFFFFFFL, 0 );
		else if (ec_line < lastline)
		{
			AttrSetColor( ec_line, lastline, 1L, 0x7FFFFFFFL, 0 );
			if (ec_line < firstline)
				firstline = ec_line;
		}

		/* Reset the attributes for the line range within _pl1_language_colors.
		 */
		_PosInit( startoff );
		_pl1_language_colors( lastline - firstline + 1 );

		/* Allow changes to be redraw 
		 */
		SysClrSystemFlags( SYSTEM_DELAY_ATTR_CHANGES );
		WinRedrawLines( WinQCurrentWindow(), firstline, lastline );
	}
}
                    
void DLL
_pl1_language_colors( long numlines )
{
	long  startoff;
	long  startline;
	long  endoff;
	long  inc;
	UINT  ch;
	LPSTR buf;
	int   i = 0;
	int   comment_color    = ColorComments( -1 );
	int   keyword_color    = ColorKeywords( -1 );
	long  maxlines         = ExtCommentSearchLimit( -1 );
	int   quote_color      = ColorAlternate1( -1 );
	int   number_color     = ColorAlternate2( -1 );
	int   brace_color      = ColorAlternate3( -1 );
	int   preproc_color    = ColorAlternate4( -1 );


	buf = (LPSTR)MemAlloc( MAX_BUF_LEN );

	/* Start at the top of the buffer or current position 
	 */
	if (numlines == -1)
	{
		_PosInit( 0 );  
		numlines = 0x7FFFFFFF;
	}
	else
	{
		startoff  = _PosQOffset();
		startline = _PosQLine();
		endoff    = _pl1_in_comment( startoff );
		if (endoff == -1)
			_PosInit( startoff );
		else
		{
			_PosInit( endoff );
			numlines += (startline - _PosQLine());
		}
	}
	ch = _PosCurrentChar();
	startoff = _PosQOffset();

	maxlines = max( numlines, maxlines );

	while ((ch != EOF_CHAR) && (numlines > 0))
	{
		if (ch == '\n')
			numlines--;

		if (ch == '"' || ch == '\'')
		{
			UINT quote = ch;

            startoff = _PosQOffset();

			do 
			{
				ch = _PosNextChar();
				if (ch == '\\')
				{
					ch = _PosNextChar();
					if ((ch == quote) || (ch == '\\') || (ch == '\n') || (ch == '\r'))
					{
						if (ch == '\n')
							numlines++;
						else if (ch == '\r')
							ch = _PosNextChar();
						ch = _PosNextChar();
					}
				}

				if ((ch == EOF_CHAR) || (ch == '\n'))
					break;
			} while (ch != quote);

			if (ch == quote)
				ch = _PosNextChar();

			/* color the string */
			if (quote_color)
			{
				endoff = _PosQOffset();
	    		_PosInit( startoff );
				_PosSetColor( quote_color, endoff - startoff );
				_PosInit( endoff );
			}
			continue;
		}
		else if (number_color && isdigit( ch ))
		{
            int j = 0;
			UINT lastch = _PosPrevChar();

			if (lastch != EOF_CHAR)
				_PosNextChar();

			startoff = _PosQOffset();
			do
			{
                j++;
				ch = _PosNextChar();
			} while (isxdigit( ch ) 
					|| (ch == '.') 
					|| (((ch == 'x') || (ch == 'X')) && j == 1));

			if ((  lastch != ' ' 
				&& lastch != '\t' 
				&& lastch != '\r' 
				&& lastch != '\n' 
				&& lastch != EOF_CHAR
				&& !ispunct( lastch ))
				|| lastch == '_'
				|| (ch == '_'))
				continue;

            if (ch == 'l' || ch == 'L')
                ch = _PosNextChar();

			endoff = _PosQOffset();
    		_PosInit( startoff );
			_PosSetColor( number_color, endoff - startoff );
			_PosInit( endoff );
			continue;
		}
		else if ( ch == '#' && preproc_color)
		{
			startoff = _PosQOffset();
			do
			{
				ch = _PosNextChar();
			} while ( ch == ' ' || ch == '\t');
			do
			{
				ch = _PosNextChar();
			} while ( !isspace(ch) && ch != EOF_CHAR);
			endoff = _PosQOffset();
    		_PosInit( startoff );
			_PosSetColor( preproc_color, endoff - startoff );
			_PosInit( endoff );
			continue;
		}
		else if (isalnum( (BYTE)ch ) || (ch == '_'))
		{
			UINT lastch = _PosPrevChar();

			if (lastch != EOF_CHAR)
				_PosNextChar();

			i = 0;
			startoff = _PosQOffset();

			do
			{
				if (i < MAX_BUF_LEN)
					buf[i++] = (char)ch;
				ch = _PosNextChar();
			} while (isalnum( (BYTE)ch ) || (ch == '_'));

			if ((lastch != ' ' 
						&& lastch != '\t' 
						&& lastch != '\r' 
						&& lastch != '\n' 
						&& lastch != EOF_CHAR
						&& !ispunct( lastch ))
					|| (ch == '_'))
				i = 0;
			continue;
		}
		else if (i)
		{
			int color = 0;
			if (_pl1_hash_names_1 && HashFindEntry( _pl1_hash_names_1, buf, i ))
				color = ColorAlternate5( -1 );
			else if (_pl1_hash_names_2 && HashFindEntry( _pl1_hash_names_2, buf, i ))
				color = ColorAlternate6( -1 );
			else if (HashFindEntry( _pl1_hash_names, buf, i ))
				color = keyword_color;

			if (color)
			{
				endoff = _PosQOffset();
				_PosInit( startoff );
				_PosSetColor( color, endoff - startoff );
				_PosInit( endoff );
			}
			i = 0;
		} 

		if (ch == '/')
		{
			startoff = _PosQOffset();
			ch = _PosNextChar();

			if (ch == '/')
			{
				inc = _PosNextLine( 1 );
				numlines--;
				endoff = _PosQOffset();
				_PosInit( startoff );
				_PosSetColor( comment_color, endoff - startoff - inc );
				_PosInit( endoff );
				ch = _PosCurrentChar();
			}
			else if (ch == '*')
			{
				long lines = 0;

				ch = _PosNextChar();
				while ((ch != EOF_CHAR) && (lines < maxlines))
				{
					if (ch == '\n')
					{
						lines++;
						numlines--;
					}
					else if (ch == '*')
					{
						ch = _PosNextChar();
						if (ch == '/')
						{
							endoff = _PosQOffset();
							_PosInit( startoff );
							_PosSetColor( comment_color, endoff - startoff + 1 );
							_PosInit( endoff );
							break;
						}
						else
							continue;
					}
					ch = _PosNextChar();
				}
				ch = _PosNextChar();
			}
			continue;
		}
		else if (brace_color && _fstrchr("{}", ch) != 0)    
		{                                        
			long coff;                            

			coff = _PosQOffset();            
			_PosInit(coff);                  
			_PosSetColor(brace_color, 1);    
			_PosInit(coff);                  
		}                                   

		ch = _PosNextChar();
	}
	MemFree( buf );
}


/*
 ** _pl1_add_keyword()
 *
 *  PARAMETERS:
 *    keyword - the keyword to add to the user-defined keyword table
 *    table   - the 1-based index of the table to which to add the keyword
 *
 *  DESCRIPTION:
 *    Provide a means of adding user-defined keywords for special
 *    coloring
 */
void DLL
_pl1_add_keyword( LPSTR keyword, int table )
{
    if (keyword && *keyword && table >= 0)
    {
        LPSTR XFAR *lpf;
        LPVOID  ht;

        switch( table )
        {
        case 0:
            ht = _pl1_hash_names;
            break;
        case 1:
            if (_pl1_hash_names_1 == NULL)
                _pl1_hash_names_1 = HashCreateTable( _pl1_hash_size_1, sizeof( LPSTR ), 0 );
            ht = _pl1_hash_names_1;
            break;
        case 2:
            if (_pl1_hash_names_2 == NULL)
                _pl1_hash_names_2 = HashCreateTable( _pl1_hash_size_2, sizeof( LPSTR ), 0 );
            ht = _pl1_hash_names_2;
            break;
        }

        lpf = (LPSTR XFAR *)HashGetEntry( ht, keyword, strlen( keyword ) );
        if (lpf)
        {
            *lpf = StrNew( keyword );
        }
    }
}


/*
 ** _pl1_assign_template()
 *
 *  PARAMETERS:
 *    abbrev   - the keyword abreviation used to locate a template
 *    template - the encoded template string associated with 'abbrev'
 *
 *  DESCRIPTION:
 *    Provide a means of adding or modifying 'PL1' template strings
 *    without changing the code.
 */
void DLL
_pl1_assign_template( LPSTR abbrev, LPSTR template )
{
    _ext_assign_template( _pl1_hash_templates, abbrev, template );
}


/*
 ** _pl1_indent()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'PL1' language smart indenting.  This function
 *    will behave differently based on the following conditions:
 *
 *    1. Within a comment - normal indentation
 *
 *    2. Not positioned at end of line - normal indentation
 *
 *    3. Current line prefixed by a name in PL1_INDENT_STR - perform smart
 *       indentation.  
 */
BOOL DLL
_pl1_indent( void )
{
    long   curline;
    long   col;
    LPSTR  _pl1_string;
    LPSTR  str;
    long   matchpos;

    MarkSavePos();

    curline = BufQCurrentLine();

    /* Check to see if we are currently positioned inside a 'PL1' comment
     */
    if (_pl1_in_comment( -1L ) != -1)
        goto _pl1_indent_incomplete;

    /* Not in a comment so indent according to the current 'PL1' construct.
     */
    if (!SrchFind( "^[ \t]*[a-zA-Z_]+\\c([ \t]|$)", SEARCH_REGEX , NIL )
            || (BufQCurrentLine() != curline) )
        goto _pl1_indent_incomplete;

    /* Read the keyword at the beginning of the current line.
     */
    col = BufQCurrentCol();
    SrchFind( "(^|[^a-zA-Z_])\\c[a-zA-Z_]", SEARCH_REGEX , NIL );
    str = BufReadStr( col - BufQCurrentCol() );
    _pl1_string = StrTrim( str, " \t" );
    StrFree( str );

    /* Set prefix and suffix to \377 to perform a quick lookup of the name
     */
    str = StrNew( "\377" );
    _pl1_string = StrAppend( _pl1_string, str );
    str = StrAppend( str, _pl1_string );
    StrFree( _pl1_string );
    
    matchpos = StrMatch( str, PL1_INDENT_STR, SEARCH_IGCASE | SEARCH_FORWARD, NIL );
    StrFree( str );

    if (!matchpos)
        /* Not a 'PL1' keyword, do normal indentation. */
        goto _pl1_indent_incomplete;
        
    MarkRestorePos();

    _ext_insert_indented_EOL();
    BufInsertChar( '\t' );
    return TRUE;

    _pl1_indent_incomplete:
        MarkRestorePos();

    return FALSE;
}

/*
 ** _pl1_routines()
 *
 *  DESCRIPTION:
 *    Locates function definitions for selective display mode.
 *    This function gets called by the Codewright API call Routines()
 *    if the current file is a .PL1 file.
 *    The code here is taken from _pl1_routines; modify it as needed.
 */
void DLL
_pl1_routines( void )
{
	int   matches = 0;
	LPSTR str     = "^[a-zA-Z0-9_].*\\((.|\n)*\\)";
	LPSTR stre    = "^[a-zA-Z0-9_].*\\((.|\n)*\\)[ \t\n]*\\c[^ \t\n]";
	long  curline;
	UINT  ch;
	long  lines;

	SysWaitStart();

	MarkSavePos();

	BufSetAscii();
	MovTopBuf();

	while (SrchFind( str, SEARCH_REGEX | SEARCH_FORWARD, 0 ))
	{
		curline = BufQCurrentLine();

		SrchFind( stre, SEARCH_REGEX | SEARCH_FORWARD, 0 );

		ch = BufReadChar();
		if (ch != ';')
		{
			if (!matches)
				AttrSetVisible( 0, 0, 0 );
			matches++;
			lines = BufQCurrentLine() - curline
						- !!(ch == '{');
			AttrSetVisible( curline, curline + (lines < 0L ? 0L : lines), 1 );
			MovHome();
		}

		if (!MovDown( 1 ))
			break; 
	}

	if (matches)
	{
		BufSetCompact();
		MarkDropPos( 1 );
		MovTopBuf();
	}
	else
		MarkRestorePos();

	SysWaitEnd();

	MsgMessage( matches ? "" : "No routines found." );
}


/*--  Private functions --*/


/*
 ** _pl1_in_string()
 *
 *  Determines whether or not the current position in the buffer is
 *  located within a 'C' string by search backward for a ". 
 *
 *  Returns BOOL
 */
static BOOL
_pl1_in_string( long offset )
{
	UINT  ch;
	long  quotes     = 0;

	/* Check to see if we are currently positioned inside a 'C' string
	 */
	_PosInit( offset );
	ch = _PosCurrentChar();

	while (TRUE)
	{
		do
		{
			if (ch == '"')
			{
				//ch = _PosPrevChar();
				quotes++;
			}
			ch = _PosPrevChar();
		} while ((ch != EOF_CHAR) && (ch != '\n'));

		if (ch == '\n')
			ch = _PosPrevChar();
	 	if (ch == '\r')
			ch = _PosPrevChar();
		if (ch != '\\')
			break;
		else
			ch = _PosPrevChar();
	}




	return ((int)quotes & 1);
}


/*
 ** _pl1_in_comment()
 *
 *  Determines whether or not the current position in the buffer is
 *  located within a 'C' comment by search backward for a // or /* 
 *  comment declaration.
 *
 *  Returns -1 if not in a comment 
 *          >= 0 indicates the offset in the buffer where the comment begins
 */
static long
_pl1_in_comment( long offset )
{
	UINT  ch;
	long  lines     = 0;
	long  maxlines = ExtCommentSearchLimit( -1 );

	/* Check to see if we are currently positioned inside a 'C' comment
	 */
	_PosInit( offset );
	ch = _PosCurrentChar();

	do
	{
		switch( ch )
		{
		case '*':
			ch = _PosPrevChar();
			if (ch == '/')    /* Found the beginning of a comment */
			{
				offset = _PosQOffset();  /* currrent line is in a comment */
				ch = _PosPrevChar();
				if ((ch != '/') || (ch == '/' && (lines==0)))
				{
					_PosInit( offset );
					return offset;
				}
			}
			break;
		case '/':
			ch = _PosPrevChar();
			if (ch == '/')
			{
				if (lines==0)
					return _PosQOffset();  /* currrent line is in a comment */
				else
					return -1;    /* Not in a comment */
			}
			else if (ch == '*')
				return -1L;    /* Not in a comment */
			break;

		case '"':
			ch = _PosPrevChar();
			while (TRUE)
			{
				while (ch != EOF_CHAR && ch != '"' && ch != '\n')
					ch = _PosPrevChar();

				if (ch == '\n')
				{
					lines++;
					ch = _PosPrevChar();
				}
			 	if (ch == '\r')
					ch = _PosPrevChar();
				if (ch != '\\')
					break;
				else
					ch = _PosPrevChar();
			}
			ch = _PosPrevChar();
			break;

		case '\n':
			lines++;
		default:
			ch = _PosPrevChar();
			break;
		}
	} while ((ch != EOF_CHAR) && (lines < maxlines));

	return -1L;
}

/*
 ** _pl1_find_comment_start()
 *
 *  Search backwards for a 'C' comment sequence. Return 1 if /<*> found
 *  and 2 if <*>/ found, 0 otherwise. Leave the current position
 *  at the beginning of the found comment.
 */
static long 
_pl1_find_comment_start( void )
{
	UINT ch    = _PosCurrentChar();
	long  lines = 0;
	long  maxlines = ExtCommentSearchLimit( -1 );

	do
	{
		if (ch == '*')
		{
			ch = _PosPrevChar();
			if (ch == '/')
			{
				long offset = _PosQOffset();  /* currrent line is in a comment */
				ch = _PosPrevChar();
				_PosInit( offset );

				if (ch == '/')
				{
					if (lines == 0)
						break;
				}
				else
					return 1;
			}
		}
		else if (ch == '/')
		{
			ch = _PosPrevChar();
			if ((ch == '/') && (lines == 0))
				break;
			if (ch == '*')
			{
				long offset = _PosQOffset();  /* currrent line is in a comment */
				ch = _PosPrevChar();
				if (ch == '/')
					return 1;
				_PosInit( offset );
				return 2;
			}
		}
		else
		{
			if (ch == '\n')
				lines++;
			else if (ch == '"')
			{
				ch = _PosPrevChar();
				while (TRUE)
				{
					while (ch != EOF_CHAR && ch != '"' && (ch == '\n'))
					{
						if (ch == '\n')
							lines++;
						ch = _PosPrevChar();
					}
					if (ch == '\n')
						ch = _PosPrevChar();
				 	if (ch == '\r')
						ch = _PosPrevChar();
					if (ch != '\\')
						break;
					else
						ch = _PosPrevChar();
				}
			}
			ch = _PosPrevChar();
		}
	} while ((ch != EOF_CHAR) && (lines < maxlines));

	return 0;
}

/*
 ** _pl1_find_comment_end()
 *
 *  Search forwards for a 'C' comment sequence. Return 1 if /<*> found
 *  and 2 if <*>/ found, 0 otherwise.  Leave the current position
 *  at the end of the found comment.
 */
static long
_pl1_find_comment_end( UINT style )
{
	long lines = 0;
	UINT ch    = _PosCurrentChar();
	long  maxlines = ExtCommentSearchLimit( -1 );

	do
	{
		if (ch == '*')
		{
			ch = _PosNextChar();
			if (ch == '/')
				return 2;
		}
		else if (ch == '/')
		{
			ch = _PosNextChar();
//			if ((ch == '/') && style)
//				break;
			if (ch == '*')
				return 1;
		}
		else
		{
			if (ch == '\n')
				lines++;
			else if (ch == '"')
			{
				int eolchars;

				ch = _PosNextChar();
				while (TRUE)
				{
					while (ch != EOF_CHAR && ch != '"' && ch != '\n')
					{
						if (ch == '\n')
							lines++;
						ch = _PosNextChar();
					}
					eolchars = 1;
					if (ch == '\n')
						ch = _PosPrevChar();
				 	if (ch == '\r')
						ch = _PosPrevChar(), eolchars = 2;
					if (ch != '\\')
						break;
					else
					{
						_PosNextChar();
						if (eolchars == 2)
							_PosNextChar();
						ch = _PosNextChar();
					}
				}
			}
			ch = _PosNextChar();
		}
	} while ((ch != EOF_CHAR) && (lines < maxlines));

	return 0;
}

